## wait4x 3.5.1

=== debian/changelog ===
wait4x (3.5.1-1) unstable; urgency=medium

  * Initial release (Closes: #1101564)

 -- Lena Voytek <lena@voytek.dev>  Fri, 29 Aug 2025 13:49:23 -0400
