=== debian/control ===
Source: wait4x
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Lena Voytek <lena@voytek.dev>,
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-sequence-golang,
               golang-any,
               golang-github-antchfx-htmlquery-dev,
               golang-github-fatih-color-dev,
               golang-github-go-logr-logr-dev,
               golang-github-go-logr-stdr-dev,
               golang-github-go-logr-zerologr-dev,
               golang-github-go-redis-redis-dev,
               golang-github-go-sql-driver-mysql-dev,
               golang-github-lib-pq-dev,
               golang-github-miekg-dns-dev,
               golang-github-rabbitmq-amqp091-go-dev,
               golang-github-rs-zerolog-dev,
               golang-github-spf13-cobra-dev,
               golang-github-stretchr-testify-dev,
               golang-github-tidwall-gjson-dev,
               golang-google-grpc-dev,
               golang-mongodb-mongo-driver-dev,
               golang-mvdan-sh-dev,
               help2man
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/wait4x
Vcs-Git: https://salsa.debian.org/go-team/packages/wait4x.git
Homepage: https://github.com/wait4x/wait4x
XS-Go-Import-Path: wait4x.dev/v3

Package: wait4x
Section: net
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Wait for a port or a service to enter the requested state. (program)
 This package provides a command-line tool to wait for a port or a service
 to enter the requested state, such as being available or returning a specific
 HTTP status code. It can be used in scripts or as part of deployment processes
 to ensure that services are ready before proceeding with further actions.

Package: golang-wait4x-wait4x-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Wait for a port or a service to enter the requested state. (library)
 This package provides a Go library to wait for a port or a service to enter
 the requested state, such as being available or returning a specific HTTP
 status code. It can be used in Go applications to ensure that services are
 ready before proceeding with further actions.
