=== debian/tests/control ===
Tests: wait4-shell-commands
Restrictions: allow-stderr

Tests: wait4-apache2
Restrictions: needs-root allow-stderr breaks-testbed
Depends: @, apache2

Tests: check-go-library
Restrictions: allow-stderr
Depends: @,
         golang-any,
         golang-github-go-logr-logr-dev,
         golang-github-stretchr-testify-dev,
         golang-github-stretchr-objx-dev,
         golang-github-davecgh-go-spew-dev,
         golang-github-pmezard-go-difflib-dev,
         golang-gopkg-yaml.v3-dev
