## wait4x 3.6.0

=== debian/changelog ===
wait4x (3.6.0-1) unstable; urgency=medium

  * New upstream release 3.6.0
  * Enable kafka support
    - d/rules: Remove disable_kafka
    - d/control: Add golang-github-segmentio-kafka-go-dev dependency
  * Update standards version and remove Priority: optional
  * Remove golang-github-go-redis-redis-dev dependency for now

 -- Lena Voytek <lena@voytek.dev>  Fri, 06 Feb 2026 14:41:03 -0500
