=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: wait4x
 Section: golang
-Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Lena Voytek <lena@voytek.dev>,
 Rules-Requires-Root: no
@@ -12,12 +11,12 @@
                golang-github-go-logr-logr-dev,
                golang-github-go-logr-stdr-dev,
                golang-github-go-logr-zerologr-dev,
-               golang-github-go-redis-redis-dev,
                golang-github-go-sql-driver-mysql-dev,
                golang-github-lib-pq-dev,
                golang-github-miekg-dns-dev,
                golang-github-rabbitmq-amqp091-go-dev,
                golang-github-rs-zerolog-dev,
+               golang-github-segmentio-kafka-go-dev,
                golang-github-spf13-cobra-dev,
                golang-github-stretchr-testify-dev,
                golang-github-tidwall-gjson-dev,
@@ -26,7 +25,7 @@
                golang-mvdan-sh-dev,
                help2man
 Testsuite: autopkgtest-pkg-go
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/go-team/packages/wait4x
 Vcs-Git: https://salsa.debian.org/go-team/packages/wait4x.git
 Homepage: https://github.com/wait4x/wait4x
