=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 export DEB_VERSION_UPSTREAM
 
 export DH_GOLANG_BUILDPKG := wait4x.dev/v3/cmd/wait4x
-export GOFLAGS := -tags=disable_influxdb,disable_kafka,disable_redis,disable_temporal
+export GOFLAGS := -tags=disable_influxdb,disable_redis,disable_temporal
 
 MAN_NAME_SECTION="Wait for a port or a service to enter the requested state"
